public class SeqMultBlockTrans implements MatrixMult {
    private int bsize;
    /**
     * Constructor with block size.
     */
    SeqMultBlockTrans(int bsize) {
        this.bsize = bsize;
    }
		
    public void multiply(double[][] C, 
                         double[][] A, 
                         double[][] B) {
        System.out.println("sequential multiply" 
     			   + " blocked transposed " + bsize);
        for (int ii = 0; ii < A.length; ii += bsize) {
            int endi = ii + bsize;
            if ( endi > A.length ) {
                endi = A.length;
            }
            for ( int jj = 0; jj < B.length; jj += bsize) {
                int endj = jj + bsize;
                if ( endj > B.length ) {
                    endj = B.length;
                }
                for (int i=ii; i < endi; i++) {
                    for (int j=jj; j < endj; j++) {
                        double c = 0.0;
                        for (int k=0; k < B[j].length; k++) {
                            c += A[i][k] * B[j][k];// tausch
                        }
                        C[i][j] = c;
                    }
                }
            }
        }
    }
}

