import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class UCMain {

    public static void main(String[] args) {
        BlockingQueue<Integer> buffer = 
            new ArrayBlockingQueue<Integer>(50);
        ExecutorService pool 
            = Executors.newCachedThreadPool();
        pool.execute( new UCErzeuger(buffer,100) );
        pool.execute( new UCVerbraucher(buffer,50) );
        pool.execute( new UCVerbraucher(buffer,50) );
			
        pool.shutdown();
        List<Runnable> rest = null; // = pool.shutdownNow();
        System.out.println("terminated, rest = " + rest);
    }
}

class UCErzeuger extends Thread {
    BlockingQueue<Integer> buffer;
    int a; 
    public UCErzeuger(BlockingQueue<Integer> b, int a) {
        buffer = b;
        this.a = a;
    }
    public void run() {
        int erwartet = 0;
        for( int i = 0; i < a; i++ ) {
            erwartet += i;
            try {
                buffer.put(i);
                Arbeit.etwasTun(1);
            } catch (InterruptedException e) {
                e.printStackTrace();
                System.out.println("shutdown " + this);
                return;
            }
        }
        System.out.println("\nerwartet = " + erwartet);
    }
}

class UCVerbraucher extends Thread {
    BlockingQueue<Integer> buffer;
    int a;
    public UCVerbraucher(BlockingQueue<Integer> b, int a) {
        buffer = b;
        this.a = a;
    }
    public void run() {
        int summe = 0;
        for ( int i = 0; i < a; i++) {
            try {
                int j = buffer.take();
                summe += j;
                Arbeit.etwasTun(30);
            } catch (InterruptedException e) {
                e.printStackTrace();
                System.out.println("shutdown " + this);
                return;
            }
        }
        System.out.println("\nsumme = " + summe);
    }
}
