import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;

public class WebServer {

    static int PORT = 8080;

    public static void main(String[] args) {
        try {
            ServerSocket so = new ServerSocket(PORT);
            System.out.println("so = " + so);
            while (true) {
                Socket s = so.accept();
                System.out.println("s = " + s);
                PrintWriter pw = new PrintWriter( 
                                     new OutputStreamWriter( s.getOutputStream() ) );
                BufferedReader br = new BufferedReader( 
                                        new InputStreamReader( s.getInputStream() ) );
                String method = br.readLine(); 
                // HTTP 0.9: GET /pfad/datei.ext
                if ( method.startsWith("GET ")) {
                    String datei = method.substring(4);
                    System.out.println("request for " + datei);
                    if ( datei.endsWith(" HTTP/1.1") 
                         || datei.endsWith(" HTTP/1.0") ) {
                        datei = datei.substring(1,datei.length()-9);
                    }
                    System.out.println("datei ist " + datei + "");
                    if ( !sendFile(datei,pw) ) {
                        pw.println("Error: ");
                    }
                } else {
                    pw.println("Error: invalid method");   
                }
                pw.close();
                br.close();
                s.close();	
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static boolean sendFile(String name, PrintWriter pw) {
        try {
            FileReader fr = new FileReader(name);
            BufferedReader br = new BufferedReader(fr);
            while (true) {
                String zeile = br.readLine();
                if ( zeile == null ) {
                    break;
                }
                pw.println(zeile);
            }
            pw.flush();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            pw.println("Error: FileNotFound");
            return false;
        } catch (IOException e) {
            e.printStackTrace();
            pw.println("Error: IO");
            return false;
        }
        return true;
    }
}
