import java.util.concurrent.Semaphore;
public class BoundedBuffer<T> {
    private T[] buffer;
    private int size;
    private int front, rear;
    private Object fsync, rsync;
    private Semaphore full;
    private Semaphore empty;
    public BoundedBuffer(int s) {
        size = s;
        buffer = (T[]) new Object[size];
        front = 0;
        rear = 0;
        fsync = new Object();
        rsync = new Object();
        full = new Semaphore(0);
        empty = new Semaphore(size);
    }
    public void put(T etwas) throws InterruptedException {
        empty.acquire(); // P - Operation
        synchronized (rsync){ 
            if ( rear >= size ) {
                rear -= size;
            }
            buffer[rear] = etwas;
            rear++;
        }
        System.out.print("+");
        full.release(); // V - Operation
    }
    public T get() throws InterruptedException {
        T etwas = null;
        full.acquire(); // P - Operation
        synchronized (fsync) {
            if ( front >= size ) {
                front -= size;
            }
            etwas = buffer[front];
            front++;
        }
        System.out.print("-");
        empty.release(); // V - Operation
        return etwas;
    }
    boolean empty() {
        return front == rear;
    }
    boolean full() {
        return (rear+1 == front) 
            || ( rear == size-1 && front == 0 );
    }
}
