import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.net.Socket;

public class ObjectChannel {
    ObjectOutputStream out;
    ObjectInputStream in;

    public ObjectChannel(Socket s) throws IOException {
        out = new ObjectOutputStream( s.getOutputStream() );
        in = new ObjectInputStream( s.getInputStream() );
    }

    public void close()	{
    	try {
            out.close();
            in.close();
    	} catch(IOException e) {
            e.printStackTrace();
    	}
    }

    public void send(Object o) throws IOException {
    	synchronized(out) {
            out.writeObject(o);
        }
    }

    public Object receive() throws IOException, ClassNotFoundException {
    	Object o = null;
    	synchronized(in) {
            o = in.readObject();
    	}
    	return o;
    }	
}
