import java.net.Socket;
import java.net.UnknownHostException;
import java.io.IOException;

class RunnableServer {

    final static int PORT = 10000;

    public static void main(String[] args) 
        throws UnknownHostException, IOException {
        String host = "localhost";
        if (args.length > 0) {
            host = args[0];
        }
        Socket s = new Socket(host,PORT);
        System.out.println("connected to " + s);
        ObjectChannel oc = new ObjectChannel(s);
        while (true) {
            try {
                Object o = oc.receive();
                System.out.println("received: " + o);
                if ( ! (o instanceof Runnable) ) {
                    System.out.println("Error: " + o);
                    continue;
                }
                Runnable r = (Runnable)o;
                r.run();
                oc.send(r);
            } catch(ClassNotFoundException e) {
                break;
            } catch(RuntimeException e) {
                break;
            }
        }
        oc.close();
        s.close();
    }   
}
