import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.atomic.AtomicInteger;

public class UCMainSubmit {

    public static void main(String[] args) {
        BlockingQueue<Integer> buffer = 
            new ArrayBlockingQueue<Integer>(50);
        ExecutorService pool 
            = Executors.newCachedThreadPool();
        AtomicInteger ze = new AtomicInteger(100);
        AtomicInteger zv = new AtomicInteger(100);
        Future[] f = new Future[4];
        f[0] = pool.submit( new UCErzeugerSub(buffer,ze) );
        f[1] = pool.submit( new UCVerbraucherSub(buffer,zv) );
        f[2] = pool.submit( new UCVerbraucherSub(buffer,zv) );
        f[3] = pool.submit( new UCErzeugerSub(buffer,ze) );
        
        pool.shutdown();
        //pool.submit( new UCVerbraucher(buffer,50) );
        Object o = null;
        try {
            o = f[0].get();
            o = f[1].get();
            o = f[2].get();
            o = f[3].get();
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        } finally {
            System.out.println("O: " + o);
        }		
        List<Runnable> rest = null; // = pool.shutdownNow();
        System.out.println("terminated, rest = " + rest);
    }
}

class UCErzeugerSub extends Thread {
    BlockingQueue<Integer> buffer;
    AtomicInteger a;
    public UCErzeugerSub(BlockingQueue<Integer> b, 
                         AtomicInteger a) {
        buffer = b;
        this.a = a;
    }
    public void run() {
        int erwartet = 0;
        for( int i = 0; a.getAndDecrement() > 0; i++ ) {
            erwartet += i;
            try {
                buffer.put(i);
                Arbeit.etwasTun(1);
            } catch (InterruptedException e) {
                e.printStackTrace();
                System.out.println("shutdown " + this);
                return;
            }
        }
        System.out.println("\nerwartet = " + erwartet);
    }
}

class UCVerbraucherSub extends Thread {
    BlockingQueue<Integer> buffer;
    AtomicInteger a;
    public UCVerbraucherSub(BlockingQueue<Integer> b, 
                            AtomicInteger a) {
        buffer = b;
        this.a = a;
    }
    public void run() {
        int summe = 0;
        for ( int i = 0; a.getAndDecrement() > 0; i++) {
            try {
                int j = buffer.take();
                summe += j;
                Arbeit.etwasTun(30);
            } catch (InterruptedException e) {
                e.printStackTrace();
                System.out.println("shutdown " + this);
                return;
            }
        }
        System.out.println("\nsumme = " + summe);
    }
}
