
package algo;

/**
 * Interface for TSP computing algorithms.
 * @author Heinz Kredel.
 */
public interface TSPInf {

    public Path actualBest();

    public void setBest(Path b);

/**
 * Search the best path for a TSP problem.
 */
    public Path getBest();


/**
 * Search the best path for a TSP problem.
 * @param max maximal number of iterations to be used or Long.MAX_VALUE.
 */
    public Path getBest(long max);


/**
 * Search the best path for a TSP problem.
 * Starting with path p.
 */
    public void getBest(Path p);


    public long getIterations();

    public long getMaxIterations();

    public long setMaxIterations(long m);

}
