#ifndef ParMultProc_h
#define ParMultProc_h

struct eight_args {
    double* C;
    double* A;
    double* B;
    int m;
    int p;
    int n;
    int i;
    int anzahl;
};

/**
 * Parallel Matrix Multiplication. 
 * Using specified number of threads.
 * @author Joachim Staats.
 */

class ParMultProc {
public:
/** 
 * Constructor.
 */
    ParMultProc(int threads) : anzahl(threads){};

/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);
private:
    int anzahl;
};


/**
 * It performs a row multiplication.
 */
void* RowMultProc (void *arg);

#endif
