#ifndef ParMultProcBlockTrans_h
#define ParMultProcBlockTrans_h

/**
 * Parallel Matrix Multiplication. 
 * Using specified number of threads, 
 * generating product matrix in blocks, matrix B is transposed.
 * @author Joachim Staats.
 */

class ParMultProcBlockTrans {
public:
/** 
 * Constructor.
 */
    ParMultProcBlockTrans(int threads, int size) : anzahl(threads), blocksize(size){};

/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * transpose(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);
private:
    int anzahl;
    int blocksize;
};

/**
 * It performs a row multiplication.
 */
void* RowMultProcBlockTrans (void *arg);

#endif
