#include "SeqMultBlockTrans.h"

#include <iostream>
#include <algorithm>

using namespace std;

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks.  
 * @author Joachim Staats.
 */

/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C matrix.
 * @param A matrix.
 * @param B double array.
 */
void SeqMultBlockTrans::multiply(double* C, double* A, double* B, int m, int p, int n) 
{
      int na = blocksize;
      int nb = blocksize;
      cout << "#blocks = " << (m/na) << ", na = " << na << " SeqMultBlockTrans ";

      for (int ii=0; ii < m; ii+=na) {
          for (int jj=0; jj < n; jj+=nb) {

              for (int i=ii; i < min((ii+na),m); i++) {
                  double* Ai = &A[i];
                  for (int j=jj; j < min((jj+nb),p); j++) {
                      double* Bj = &B[j];
                      double c = 0.0;
                      for (int k=0; k < n; k++) {
                          c += Ai[k] * Bj[k];
                      }
                      C[i*p+j] = c;
                  }
              }
          }
      }
}
