#ifndef SeqMultBlockTrans_h
#define SeqMultBlockTrans_h

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks. 
 * matrix B transposed. 
 * @author Joachim Staats.
 */

class SeqMultBlockTrans {
public:
/** 
 * Constructor.
 */
    SeqMultBlockTrans(int size) : blocksize(size){};

/**
 * Performs the multiplication of two matrices.
 * C = A * trans(B).
 * @param C matrix.
 * @param A matrix.
 * @param B double array.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);

private:
    int blocksize;
};

#endif
