#include "SeqMultTrans.h"

#include <iostream>

using namespace std;

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, matrix is B transposed.  
 * @author Joachim Staats.
 */

/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * trans(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
void SeqMultTrans::multiply(double* C, double* A, double* B, int m, int p, int n)
{
    cout << "SeqMultTrans ";
    for (int i=0; i < m; i++) {
        double* Ai = &A[i];
        for (int j=0; j < n; j++) {
            double* Bj = &B[j];
            double c = 0.0;
            for (int k=0; k < p; k++) {
                c += Ai[k] * Bj[k];
            }
            C[i*n+j] = c;
        }
    }
}

