/*
 * $Id: HelloMPP.java,v 1.5 2002/08/03 17:17:42 kredel Exp $
 */
import java.io.IOException;
import mpp.Communicator;
import mpp.BlockCommunicator;
import mpp.StreamCommunicator;

/**
 * HelloMPP.
 * @author from the MPI examples, adapted for MPP.
 */
public  class HelloMPP {

    static public void main(String[] args) throws IOException {

      //MPI.Init(args) ;
      Communicator mpi_comm_world = new BlockCommunicator();
      //Communicator mpi_comm_world = new StreamCommunicator();

      int myrank = mpi_comm_world.rank();
      int size   = mpi_comm_world.size();

      int msglength = "Hello, there".length();
      if(myrank == 0) {
        char [] message = "Hello, there".toCharArray() ;
        System.out.println("send("+myrank+"|"+size+"): " + new String(message) + " :");

        mpi_comm_world.send(message, 0, msglength, size-1);
     }
      else {
        char [] mymessage = new char [20];
        System.out.print("receive("+myrank+"|"+size+")");

        mpi_comm_world.recv(mymessage, 0, msglength/*-5*/, 0);
        System.out.println(": " + new String(mymessage) + ":") ;
      }
 
      //MPI.Finalize();
      mpi_comm_world.close();
    }

}
