
import java.io.IOException;


/**
 * ObjectChannel.
 * This interface defines a communication channel for objects.
 * @author Heinz Kredel.
 */

public interface ObjectChannel {

  /**
   * Sends an object.
   */
  public void send(Object v) throws IOException;


  /**
   * Receives an object.
   */
  public Object receive() throws IOException, ClassNotFoundException;


  /**
   * Closes the channel.
   */
  public void close();

}
