
/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks.  
 * @author Heinz Kredel.
 */

public class SeqMultBlock implements MMInf {

    int blocksize = 1;

    public SeqMultBlock(int size) {
         this.blocksize = size;	
    }


/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C matrix.
 * @param A matrix.
 * @param B double array.
 */
    public void multiply(double[][] C, double[][] A, double[][] B) {

      int na = blocksize;
      int nb = blocksize;
      System.out.println("#blocks = " + (A.length/na) + ", na = " + na 
          + " SeqMultBlock");

      for (int ii=0; ii < A.length; ii+=na) {
          for (int jj=0; jj < B[0].length; jj+=nb) {

              for (int i=ii; i < Math.min((ii+na),A.length); i++) {
                  double[] Ai = A[i];
                  for (int j=jj; j < Math.min((jj+nb),B[0].length); j++) {
                      double c = 0.0;
                      for (int k=0; k < B.length; k++) {
                          c += Ai[k] * B[k][j];
                      }
                      C[i][j] = c;
                  }
              }

          }
      }

    }

}
