
import java.io.Serializable;
import java.util.Random;

/**
 * A Point in a Graph
 */

public class Point implements Serializable {

    public final int n;
    public final double x;
    public final double y;

    public Point(int n, double x, double y) {
        this.n = n;
        this.x = x;
        this.y = y;
    }

    public String toString() {
        return "["+n+"]("+x+","+y+")";
    }

    public static Point random(int n, Random r, double m) {
        return new Point(n,
                         Math.abs(r.nextDouble()*m),
                         Math.abs(r.nextDouble()*m));
    }

}