public class SeqMultBlock implements MatrixMult {
    private int bsize;
    /**
     * Constructor with block size.
     */
    SeqMultBlock(int bsize) {
        this.bsize = bsize;
    }
	
    public void multiply(double[][] C, 
                         double[][] A, 
                         double[][] B) {
        System.out.println("sequential multiply blocked " );
        for (int ii = 0; ii < A.length; ii += bsize) {
            int endi = ii + bsize;
            if ( endi > A.length ) {
                endi = A.length;
            }
            for ( int jj = 0; jj < B[0].length; jj += bsize) {
                int endj = jj + bsize;
                if ( endj > B[0].length ) {
                    endj = B[0].length;
                }
                for (int i=ii; i < endi; i++) {
                    for (int j=jj; j < endj; j++) {
                        double c = 0.0;
                        for (int k=0; k < B.length; k++) {
                            c += A[i][k] * B[k][j];
                        }
                        C[i][j] = c;
                    }
                }
            }
        }
    }
}
